CREATE DATABASE SEBEAPPS COLLATE USING SYSTEM PAGESIZE 32768;
connect to SEBEAPPS;

grant dataaccess on database to group db2sadm;

create schema seb;

create table seb.setting (
	setting_key varchar(100) not null,
	setting_value varchar(500) not null,
	primary key(setting_key)
);

insert into seb.setting (setting_key, setting_value) values ('CONTRACT_MAX_SUBSCRIPTION', '2');
insert into seb.setting (setting_key, setting_value) values ('ACTIVATION_CODE_EXPIRE_MINUTES', '10');
insert into seb.setting (setting_key, setting_value) values ('ACTIVATION_CODE_REQUEST_WAIT_MINUTES', '3');
insert into seb.setting (setting_key, setting_value) values ('SESSION_REMEMBER_ME_MONTHS', '-1');
insert into seb.setting (setting_key, setting_value) values ('EMAIL_SENDER_ADDRESS', 'customercare@sarawakenergy.com.my');
insert into seb.setting (setting_key, setting_value) values ('TESTING_ENVIRONMENT', 'true');
insert into seb.setting (setting_key, setting_value) values ('STATEMENT_ROOT_PATH', '/opt/application/statement');
insert into seb.setting (setting_key, setting_value) values ('NOTIFICATION_SEND_PATIENT_MINUTES', '5');
insert into seb.setting (setting_key, setting_value) values ('SMS_USER_ID', 'mktest56');
insert into seb.setting (setting_key, setting_value) values ('SMS_USER_PASSWORD', 'SEB3015ygk');
insert into seb.setting (setting_key, setting_value) values ('CASE_REPORT_CHECK_SECOND', '10');
insert into seb.setting (setting_key, setting_value) values ('PAYMENT_HISTORY_LISTING_ENTRIES', '6');
insert into seb.setting (setting_key, setting_value) values ('STATEMENT_LISTING_ENTRIES', '3');
insert into seb.setting (setting_key, setting_value) values ('SECRET', 'sar@w@k.3nergy^@*%');
insert into seb.setting (setting_key, setting_value) values ('SAP_FILE_PROCESSING_NOTIFY_RECIPIENTS', 'peirhwa.soo@isentric.com,paul.kanwj@sarawakenergy.com.my,pohpc@sarawakenergy.com.my');
insert into seb.setting (setting_key, setting_value) values ('POWER_ALERT_PUBLISH_DELAY', '3');
insert into seb.setting (setting_key, setting_value) values ('CHECKER_EMAIL', 'woon.san.yap@isentric.com');
insert into seb.setting (setting_key, setting_value) values ('IMAGE_MAX_BYTES', '204800');
insert into seb.setting (setting_key, setting_value) values ('FAQ_URL', 'https://sebcares.sarawakenergy.com.my/eServices/index.html#/faq');
insert into seb.setting (setting_key, setting_value) values ('SAP_TIMEOUT_SECONDS', '180');

create table seb.user (
	user_id varchar(50) not null,
	status varchar(10) not null,
	profile_photo blob null,
	profile_photo_type varchar(20) null,
	preferred_communication_method varchar(10) null,
	existing_email varchar(50) null,
	existing_password varchar(64) null,
	preferred_locale varchar(2) null,
	flag_password_expired integer not null with default 0,
	current_login_at timestamp null,
	last_login_at timestamp null,
	created_datetime timestamp with default current timestamp not null,
	primary key (user_id)
);

create index idx_user_existing_email on seb.user (existing_email);

create table seb.remember_me (
	client_id varchar(100) not null,
	user_email varchar(50) not null,
	expiry_date timestamp null,
	primary key (client_id)
);

create index idx_remember_me on seb.remember_me (user_email);

create table seb.subscription (
	subs_id integer not null generated always as identity (start with 1, increment by 1, cache 20, no minvalue, no maxvalue, no cycle, no order),
	user_email varchar(50) not null, 
	contract_account_number varchar(12) not null,
	contract_account_nick varchar(255) not null,
	subs_type varchar(30) not null,
	status varchar(10) not null with default 'ACTIVE',
	updated_datetime timestamp generated by default for each row on update as row change timestamp not null,
	created_datetime timestamp with default current timestamp not null,
	primary key (subs_id)
);

create index idx_subscription_user on seb.subscription (user_email);
create unique index idx_unique_subscription on seb.subscription (user_email, contract_account_number);
create index idx_subscription_search on seb.subscription (contract_account_number,status);

create table seb.contract(
	contract_account_number varchar(12) not null,
	contract_account_name varchar(255) not null,
	agency_name varchar(10) null,
	primary key (contract_account_number)
);
 
create table seb.agency (
	agency_name char(10) not null, 
	primary key (agency_name)
);

create table seb.billing (
	billing_id bigint not null generated always as identity (start with 1, increment by 1, cache 20, no minvalue, no maxvalue, no cycle, no order),
	agency_name varchar(10) not null, 
	process_date timestamp not null, 
	primary key (billing_id)
);

create table seb.billing_transaction (
	billing_id bigint null,
	invoice_number varchar(12) not null,
	contract_account_number varchar(12) not null,
	business_partner_number varchar(10) not null,
	invoice_date timestamp not null,
	due_date timestamp not null,
	current_amount decimal(13,2) not null,
	current_total_amount decimal(13,2) not null,
	bill_start_date timestamp null,
	bill_end_date timestamp null,
	pdf_print_document_number varchar(70) not null,
	primary key(invoice_number)
);

create index idx_billing_transaction on seb.billing_transaction (contract_account_number,invoice_date);

create table seb.email_verification (
	verification_id bigint not null generated always as identity (start with 1, increment by 1, cache 20, no minvalue, no maxvalue, no cycle, no order),
	user_email varchar(50) not null,
	status varchar(10) not null,
	code varchar(80) not null,
	created_datetime timestamp with default current timestamp not null,
	primary key (verification_id)
);

create index idx_email_verification on seb.email_verification (user_email,status);

create table seb.mobile_verification (
	verification_id bigint not null generated always as identity (start with 1, increment by 1, cache 20, no minvalue, no maxvalue, no cycle, no order),
	mobile_number varchar(20) not null,
	status varchar(10) not null,
	code varchar(80) not null,
	created_datetime timestamp with default current timestamp not null,
	primary key (verification_id)
);

create index idx_mobile_verification on seb.mobile_verification (mobile_number,status);

create table seb.otp_verification (
	verification_id bigint not null generated always as identity (start with 1, increment by 1, cache 20, no minvalue, no maxvalue, no cycle, no order),
	user_email varchar(50) not null,
	status varchar(10) not null,
	code varchar(80) not null,
	created_datetime timestamp with default current timestamp not null,
	primary key (verification_id)
);

create index idx_otp_verification on seb.otp_verification (user_email,status);

create table seb.report (
	trans_id integer not null generated always as identity (start with 1, increment by 1, cache 20, no minvalue, no maxvalue, no cycle, no order),
	case_number integer null,
	case_id varchar(50) null,
	doc_id varchar(50) null,
	report_type varchar(30) not null,
	status varchar(60) not null,
	previous_notified_status varchar(60) null,
	contract_account_number varchar(12) null,
	channel varchar(20) not null,
	client_os varchar(255) not null,
	user_email varchar(50) not null,
	user_name varchar(160) not null,
	user_mobile_number varchar(20) not null,
	station varchar(20) null,
	description varchar(300) not null,
	loc_longitude varchar(15) null,
	loc_latitude varchar(15) null,
	loc_address varchar(100) null,
	photo_1 blob null,
	photo_1_type varchar(20) null,
	photo_2 blob null,
	photo_2_type varchar(20) null,
	photo_3 blob null,
	photo_3_type varchar(20) null,
	updated_datetime timestamp generated always for each row on update as row change timestamp not null,
	created_datetime timestamp with default current timestamp not null,
	primary key (trans_id)
);

create index idx_report_last_update on seb.report (updated_datetime);
create index idx_report_email on seb.report (user_email);
create index idx_report_case_number on seb.report (case_number);
create index idx_report_case_id on seb.report (case_id);
create index idx_report_doc_id on seb.report (doc_id);

create table seb.tag_notification (
	notification_id integer not null generated always as identity (start with 1, increment by 1, cache 20, no minvalue, no maxvalue, no cycle, no order),
	text varchar(120) not null,
	notification_type varchar(20),
	associated_id integer null,
	power_alert_type varchar(50) default null,
	tag_name varchar(50) not null,
	status varchar(10) not null,
	push_datetime timestamp not null,
	sending_datetime timestamp null,
	send_counter integer not null default 0,
	created_datetime timestamp with default current timestamp not null,
	primary key(notification_id)
);

create index idx_tag_notification on seb.tag_notification (status, sending_datetime, send_counter);

create index idx_tag_notification_type on seb.tag_notification (notification_type, associated_id);

create table seb.report_notification (
	notification_id integer not null generated always as identity (start with 1, increment by 1, cache 20, no minvalue, no maxvalue, no cycle, no order),
	user_email varchar(50) not null,
	text varchar(120) not null,
	trans_id integer not null,
	status varchar(10) not null,
	sending_datetime timestamp null,
	send_counter integer not null default 0,
	created_datetime timestamp with default current timestamp not null,
	primary key(notification_id)
);

create index idx_report_notification on seb.report_notification (status, sending_datetime, send_counter);

create table seb.notification_history (
	notification_id integer not null generated always as identity (start with 1, increment by 1, cache 20, no minvalue, no maxvalue, no cycle, no order),
	user_email varchar(50) not null,
	title varchar(120) null,
	text varchar(120) not null,
	notification_type varchar(15) not null,
	associated_id integer null,
	status varchar(15) not null,
	created_datetime timestamp with default current timestamp not null,
	primary key(notification_id)
);

create index idx_notification_history on seb.notification_history (user_email);

create table seb.tag_subscriptions (
	user_email varchar(50) not null,
	tag_name varchar(50) not null,
	created_datetime timestamp with default current timestamp not null,
	primary key(user_email,tag_name)
);

create index idx_tag_subscriptions on seb.tag_subscriptions (tag_name);

create table seb.task_tracker (
	task_key varchar(100) not null,
	task_datetime timestamp null, 
	primary key(task_key)
);

insert into seb.task_tracker (task_key, task_datetime) values ('REPORT_NOTIFICATION_CHECK', CURRENT_TIMESTAMP);
insert into seb.task_tracker (task_key, task_datetime) values ('GEN_SUB_FILE', CURRENT_TIMESTAMP);

create table seb.customer_audit_trail (
	audit_id integer not null generated by default as identity (start with 1, increment by 1, cache 20, no minvalue, no maxvalue, no cycle, no order),
	user_id varchar(50) not null,
	activity varchar(500) default null,
	success integer not null,
	audit_datetime timestamp with default current timestamp not null,
	primary key (audit_id)
);

create index idx_customer_audit_trail_success on seb.customer_audit_trail (success);
create index idx_customer_audit_trail_user_id on seb.customer_audit_trail (user_id);
create index idx_customer_audit_trail_date on seb.customer_audit_trail (audit_datetime);


create table seb.report_audit (
	audit_id integer not null generated always as identity (start with 1, increment by 1, cache 20, no minvalue, no maxvalue, no cycle, no order),
	trans_id integer not null,
	db_user_id varchar(20) not null,
	new_status varchar(60) not null,
	old_status varchar(60) not null,
	audit_datetime timestamp with default current timestamp not null,
	primary key (audit_id)
);

create index idx_report_audit_trans_id on seb.report_audit (trans_id);

CREATE or replace TRIGGER SEB_REPORT_BEFORE_UPDATE AFTER UPDATE OF status ON seb.report REFERENCING OLD AS oldRow  NEW AS newRow FOR EACH ROW WHEN (1=1) BEGIN INSERT INTO seb.report_audit (trans_id, db_user_id, new_status, old_status) values (oldRow.trans_id, USER, newRow.status, oldRow.status);END 


---- CMS -----
 
create table seb.admin_user (
	id integer not null generated always as identity (start with 1, increment by 1, cache 20, no minvalue, no maxvalue, no cycle, no order),
	login_id varchar(160) unique not null,
	password varchar(160) default null,
	name varchar(160) default null,
	department varchar(160) default null,
	role varchar(160) default null,
	status varchar(25) default 'active' not null,
	last_logged_in  timestamp  default  null,
	created_datetime timestamp not null with default,
	updated_datetime timestamp generated always for each row on update as row change timestamp not null,
	deleted_flag integer not null with default,
	primary key (id)
);  

insert into seb.admin_user (login_id,password,name,department,role,status,deleted_flag) values ('sebadmin','8724fb182d73d09cf1cba6a76ef58b09','Administrator','Administrator','ROLE_A','ACTIVE',0);

CREATE TABLE SEB.NEWS (
  ID INTEGER NOT NULL GENERATED ALWAYS
    AS IDENTITY (START WITH 1, INCREMENT BY 1, CACHE 20,
       NO MINVALUE, NO MAXVALUE, NO CYCLE, NO ORDER),
  TITLE VARCHAR(100),
  IMAGE_S BLOB(10000K) NOT LOGGED NOT COMPACT,
  IMAGE_S_FILE_TYPE VARCHAR(20),
  IMAGE_L BLOB(10000K) NOT LOGGED NOT COMPACT,
  IMAGE_L_FILE_TYPE VARCHAR(20),
  DESCRIPTION CLOB(50K)  DEFAULT NULL,
  START_DATETIME   TIMESTAMP NOT NULL WITH DEFAULT,
  END_DATETIME    TIMESTAMP NOT NULL WITH DEFAULT,
  PUBLISH_DATETIME    TIMESTAMP NOT NULL WITH DEFAULT,
  CREATED_DATETIME TIMESTAMP NOT NULL WITH DEFAULT,
  UPDATED_DATETIME TIMESTAMP GENERATED ALWAYS FOR EACH ROW ON UPDATE AS ROW CHANGE TIMESTAMP NOT NULL,
  DELETED_FLAG INTEGER NOT NULL WITH DEFAULT ,
  PRIMARY KEY (ID)
) ;

create table seb.audit_trail_type (
	id integer not null generated always as identity (start with 1, increment by 1, cache 20, no minvalue, no maxvalue, no cycle, no order),
	name varchar(255) unique not null,
	deleted_flag integer not null with default,
	primary key (id)
);

create table seb.audit_trail (
	id integer not null generated always as identity (start with 1, increment by 1, cache 20, no minvalue, no maxvalue, no cycle, no order),
	admin_user_id integer default null,
	audit_trail_type_id integer default null,
	activity varchar(500) default null,
	old_value clob(50k) default null,
	new_value clob(50k) default null,
	remark  clob(50k) default null,
	ip_address varchar(255) default null,
	audit_datetime timestamp not null with default,
	deleted_flag integer not null with default 0,
	primary key (id),
	foreign key admin_user_at_fk (admin_user_id) references seb.admin_user on delete no action,
	foreign key audit_trail_type_at_fk (audit_trail_type_id) references seb.audit_trail_type on delete no action
);

INSERT INTO SEB.AUDIT_TRAIL_TYPE(NAME) VALUES('Login');                 
INSERT INTO SEB.AUDIT_TRAIL_TYPE(NAME) VALUES('Logout');                  
INSERT INTO SEB.AUDIT_TRAIL_TYPE(NAME) VALUES('Change Password');          
INSERT INTO SEB.AUDIT_TRAIL_TYPE(NAME) VALUES('Service Counter Locator'); 
INSERT INTO SEB.AUDIT_TRAIL_TYPE(NAME) VALUES('News');                    
INSERT INTO SEB.AUDIT_TRAIL_TYPE(NAME) VALUES('Outage Alert');             
INSERT INTO SEB.AUDIT_TRAIL_TYPE(NAME) VALUES('FAQ');                     
INSERT INTO SEB.AUDIT_TRAIL_TYPE(NAME) VALUES('Contact Us');              
INSERT INTO SEB.AUDIT_TRAIL_TYPE(NAME) VALUES('Policy');                  
INSERT INTO SEB.AUDIT_TRAIL_TYPE(NAME) VALUES('Audit Trail');             
INSERT INTO SEB.AUDIT_TRAIL_TYPE(NAME) VALUES('User Management');         
INSERT INTO SEB.AUDIT_TRAIL_TYPE(NAME) VALUES('Make A Report');           
INSERT INTO SEB.AUDIT_TRAIL_TYPE(NAME) VALUES('Push Notification');       
INSERT INTO SEB.AUDIT_TRAIL_TYPE(NAME) VALUES('Customer Activities Report');
INSERT INTO SEB.AUDIT_TRAIL_TYPE(NAME) VALUES('Customer Profile');        
INSERT INTO SEB.AUDIT_TRAIL_TYPE(NAME) VALUES('Customer History');        
INSERT INTO SEB.AUDIT_TRAIL_TYPE(NAME) VALUES('Customer Reset Password'); 


create table seb.cust_service_location (
	id integer not null generated always as identity (start with 1, increment by 1, cache 20, no minvalue, no maxvalue, no cycle, no order),
	region varchar(100) default null,
	station  varchar(100) default null,
	deleted_flag integer not null with default ,
	primary key (id)
);

insert into SEB.CUST_SERVICE_LOCATION(region,station,deleted_flag) VALUES('Western','Kuching',0);
insert into SEB.CUST_SERVICE_LOCATION(region,station,deleted_flag) VALUES('Western','Lundu',0);
insert into SEB.CUST_SERVICE_LOCATION(region,station,deleted_flag) VALUES('Western','Bau',0);
insert into SEB.CUST_SERVICE_LOCATION(region,station,deleted_flag) VALUES('Western','Siburan',0);
insert into SEB.CUST_SERVICE_LOCATION(region,station,deleted_flag) VALUES('Western','Kota Samarahan',0);
insert into SEB.CUST_SERVICE_LOCATION(region,station,deleted_flag) VALUES('Western','Simunjan',0);
insert into SEB.CUST_SERVICE_LOCATION(region,station,deleted_flag) VALUES('Western','Serian',0);
insert into SEB.CUST_SERVICE_LOCATION(region,station,deleted_flag) VALUES('Western','Sri Aman',0);
insert into SEB.CUST_SERVICE_LOCATION(region,station,deleted_flag) VALUES('Western','Betong',0);
insert into SEB.CUST_SERVICE_LOCATION(region,station,deleted_flag) VALUES('Western','Saratok',0);
insert into SEB.CUST_SERVICE_LOCATION(region,station,deleted_flag) VALUES('Western','Pusa',0);
insert into SEB.CUST_SERVICE_LOCATION(region,station,deleted_flag) VALUES('Central','Sibu',0);
insert into SEB.CUST_SERVICE_LOCATION(region,station,deleted_flag) VALUES('Central','Kanowit',0);
insert into SEB.CUST_SERVICE_LOCATION(region,station,deleted_flag) VALUES('Central','Kapit',0);
insert into SEB.CUST_SERVICE_LOCATION(region,station,deleted_flag) VALUES('Central','Mukah',0);
insert into SEB.CUST_SERVICE_LOCATION(region,station,deleted_flag) VALUES('Central','Dalat',0);
insert into SEB.CUST_SERVICE_LOCATION(region,station,deleted_flag) VALUES('Central','Daro',0);
insert into SEB.CUST_SERVICE_LOCATION(region,station,deleted_flag) VALUES('Central','Sarikei',0);
insert into SEB.CUST_SERVICE_LOCATION(region,station,deleted_flag) VALUES('Central','Bintangor',0);
insert into SEB.CUST_SERVICE_LOCATION(region,station,deleted_flag) VALUES('Central','Belawai',0);
insert into SEB.CUST_SERVICE_LOCATION(region,station,deleted_flag) VALUES('Northern','Miri',0);
insert into SEB.CUST_SERVICE_LOCATION(region,station,deleted_flag) VALUES('Northern','Bekenu',0);
insert into SEB.CUST_SERVICE_LOCATION(region,station,deleted_flag) VALUES('Northern','Marudi',0);
insert into SEB.CUST_SERVICE_LOCATION(region,station,deleted_flag) VALUES('Northern','Bintulu',0);
insert into SEB.CUST_SERVICE_LOCATION(region,station,deleted_flag) VALUES('Northern','Limbang',0);
insert into SEB.CUST_SERVICE_LOCATION(region,station,deleted_flag) VALUES('Northern','Lawas',0);

create table seb.cust_service_counter (
	id integer not null generated always as identity (start with 1, increment by 1, cache 20, no minvalue, no maxvalue, no cycle, no order),
	cust_service_location_id integer default null,
	admin_user_id integer default null,
	address_line1  varchar(255) default null,
	address_line2  varchar(255) default null,
	address_line3  varchar(255) default null,
	postcode  varchar(255) default null,
	city varchar(255) default null,
	opening_hour  varchar(255) default null,
	latitude double not null with default,
	longitude double not null with default,
	remark  varchar(600) default null,
	status varchar(25) not null with default 'p',
	approver_id integer default null,
	reject_reason varchar(600) default null,
	created_datetime timestamp not null with default,
	updated_datetime timestamp generated always for each row on update as row change timestamp not null,
	deleted_flag integer not null with default ,
	primary key (id),
	foreign key cust_service_location_fk (cust_service_location_id) references seb.cust_service_location on delete no action
);

create table seb.power_alert_type (
	id	integer	not null	generated always as identity (start with 1, increment by 1, cache 20, no minvalue, no maxvalue, no cycle, no order), 
	name  varchar(255) default null,
	created_datetime timestamp not null with default,
	deleted_flag	integer not null with default ,
	primary key (id)
);

insert into seb.power_alert_type (name) values('outage announcement');
insert into seb.power_alert_type (name) values('preventive maintenance');

create table seb.power_alert (
	 id	integer	not null	generated always
		as identity (start with 1, increment by 1, cache 20,
			 no minvalue, no maxvalue, no cycle, no order),
	power_alert_type_id integer default null,	 
	cust_service_location_id integer default null,
	area	varchar(500) default null,
	title varchar(200) default null,
	causes varchar(500) default null,
	restoration_datetime timestamp not null with default,
	maintenance_start_datetime timestamp not null with default,
	maintenance_end_datetime timestamp not null with default,
	created_datetime timestamp not null with default,
	updated_datetime timestamp generated always for each row on update as row change timestamp not null,
	deleted_flag	integer not null with default ,
	primary key (id),
	foreign key power_alert_type_fk (power_alert_type_id) references seb.power_alert_type on delete no action,
	foreign key cust_service_location_id_fk (cust_service_location_id) references seb.cust_service_location on delete no action
);

create table seb.faq_category (
   id	integer	not null	generated always
    as identity (start with 1, increment by 1, cache 20,
       no minvalue, no maxvalue, no cycle, no order), 
  name  varchar(255) default null,
  description  varchar(255) default null,
  deleted_flag	integer not null with default ,
  primary key (id)
);

insert into seb.faq_category (name,description)values('getting_started','Getting Started');
insert into seb.faq_category (name,description)values('account_management','Account Management');
insert into seb.faq_category (name,description)values('bill_management','Bill Management');
insert into seb.faq_category (name,description)values('report_management','Report Management');
insert into seb.faq_category (name,description)values('security','Security');
insert into seb.faq_category (name,description)values('contact_support','Contact & Support'); 

create table seb.faq (
   id	integer	not null	generated always
    as identity (start with 1, increment by 1, cache 20,
       no minvalue, no maxvalue, no cycle, no order),
  faq_category_id integer not null,  
  question_en varchar(310) default null,
  answer_en CLOB(50K) DEFAULT NULL,
  question_bm varchar(310) default null,
  answer_bm CLOB(50K) DEFAULT NULL,
  question_cn clob(50k) default null,
  answer_cn clob(50k)  default null,
  faq_sequence integer not null with default,
  status varchar(10) default 'ACTIVE' not null,
  deleted_flag integer not null with default,
  created_datetime timestamp not null with default,
  updated_datetime timestamp generated always for each row on update as row change timestamp not null,
  primary key (id),
  foreign key faq_category_fk (faq_category_id) references seb.faq_category on delete no action
 );

 
create table seb.contact_us (
	 id	integer	not null generated always
		as identity (start with 1, increment by 1, cache 20,
			 no minvalue, no maxvalue, no cycle, no order),
	tel_no varchar(20) default null,
	fax_no varchar(20) default null,
	email varchar(50) default null,
	address varchar(300) default null,
	web_url varchar(200) default null,
	deleted_flag integer not null with default,
	created_datetime timestamp not null with default,
	updated_datetime timestamp generated always for each row on update as row change timestamp not null,
	primary key (id)
 );
 
INSERT INTO seb.contact_us(TEL_NO, FAX_NO, EMAIL, ADDRESS, WEB_URL, DELETED_FLAG) VALUES('1300-88-3111', '+6082-313588', 'customercare@sarawakenergy.com.my', 'Sarawak Energy Berhad'|| chr(10) ||'Menara Sarawak Energy,' || chr(10) || 'No. 1, The Isthmus,'|| chr(10) ||'93050 Kuching,'|| chr(10) ||'Sarawak, Malaysia.', 'http://www.sarawakenergy.com.my/', 0);

 
 create table seb.portal_module (
	 id	integer	not null	generated always
		as identity (start with 1, increment by 1, cache 20,
			 no minvalue, no maxvalue, no cycle, no order),
	name	varchar(100)	 default null,
	description	varchar(255)	default null,
	module_code	 varchar(100)	default null,
	category	varchar(100)	default null,
	access_url	varchar(100)	default null,
	image_content clob(50k) default null,
	parent_module_code	 varchar(100)	 default null,
	sub_module_name varchar(255)	default null,
	level	integer,
	role varchar(255)	default null,
	created_datetime timestamp not null with default,
	updated_datetime timestamp generated always for each row on update as row change timestamp not null,
	deleted_flag	integer not null with default,
	primary key (id)
 );

INSERT INTO SEB.PORTAL_MODULE (NAME,DESCRIPTION,MODULE_CODE,CATEGORY,ACCESS_URL,IMAGE_CONTENT,PARENT_MODULE_CODE,LEVEL,ROLE,SUB_MODULE_NAME) VALUES ('Customer Enquiry','Customer Enquiry','01','Customer Enquiry','','<span class="glyphicon glyphicon-user" aria-hidden="true"></span>','0',1,'ROLE_A;ROLE_N;ROLE_C;ROLE_MAKER','');

INSERT INTO SEB.PORTAL_MODULE (NAME,DESCRIPTION,MODULE_CODE,CATEGORY,ACCESS_URL,IMAGE_CONTENT,PARENT_MODULE_CODE,LEVEL,ROLE,SUB_MODULE_NAME) VALUES ('Profile','Customer Enquiry>Profile','01.01','Customer Enquiry','/admin/customerProfile.do','','01',2,'ROLE_A;ROLE_N;ROLE_C;ROLE_MAKER','');

INSERT INTO SEB.PORTAL_MODULE (NAME,DESCRIPTION,MODULE_CODE,CATEGORY,ACCESS_URL,IMAGE_CONTENT,PARENT_MODULE_CODE,LEVEL,ROLE,SUB_MODULE_NAME) VALUES ('History','Customer Enquiry>History','01.02','Customer Enquiry','/admin/customerHistory.do','','01',2,'ROLE_A;ROLE_N;ROLE_C;ROLE_MAKER','');

INSERT INTO SEB.PORTAL_MODULE (NAME,DESCRIPTION,MODULE_CODE,CATEGORY,ACCESS_URL,IMAGE_CONTENT,PARENT_MODULE_CODE,LEVEL,ROLE,SUB_MODULE_NAME) VALUES ('Reset Password','Customer Enquiry>Reset Password','01.03','Customer Enquiry','/admin/customerResetPassword.do','','01',2,'ROLE_A;ROLE_N;ROLE_C;ROLE_MAKER','');

INSERT INTO SEB.PORTAL_MODULE (NAME,DESCRIPTION,MODULE_CODE,CATEGORY,ACCESS_URL,IMAGE_CONTENT,PARENT_MODULE_CODE,LEVEL,ROLE,SUB_MODULE_NAME) VALUES ('Maintenance ','Maintenance','02','Maintenance ','','<span class="glyphicon glyphicon-cog" aria-hidden="true"></span>','0',1,'ROLE_A;ROLE_N;ROLE_C;ROLE_MAKER','');

INSERT INTO SEB.PORTAL_MODULE (NAME,DESCRIPTION,MODULE_CODE,CATEGORY,ACCESS_URL,IMAGE_CONTENT,PARENT_MODULE_CODE,LEVEL,ROLE,SUB_MODULE_NAME) VALUES ('Service Counter Locator','Maintenance-Service Counter Locator(Checker)','02.01','Maintenance','/admin/editCSC.do','','02',2,'ROLE_C;','');

INSERT INTO SEB.PORTAL_MODULE (NAME,DESCRIPTION,MODULE_CODE,CATEGORY,ACCESS_URL,IMAGE_CONTENT,PARENT_MODULE_CODE,LEVEL,ROLE,SUB_MODULE_NAME) VALUES ('Service Counter Locator','Maintenance-Service Counter Locator (Maker)','02.01','Maintenance','','','02',2,'ROLE_M;ROLE_A','');

INSERT INTO SEB.PORTAL_MODULE (NAME,DESCRIPTION,MODULE_CODE,CATEGORY,ACCESS_URL,IMAGE_CONTENT,PARENT_MODULE_CODE,LEVEL,ROLE,SUB_MODULE_NAME) VALUES ('Add','Maintenance-Service Counter Locator(Maker)>Add','02.01.01','Maintenance','/admin/addCSC.do','','02.01',3,'ROLE_M;ROLE_A','Service Counter Locator(Maker)');

INSERT INTO SEB.PORTAL_MODULE (NAME,DESCRIPTION,MODULE_CODE,CATEGORY,ACCESS_URL,IMAGE_CONTENT,PARENT_MODULE_CODE,LEVEL,ROLE,SUB_MODULE_NAME) VALUES ('Edit','Maintenance-Service Counter Locator(Maker)>Edit','02.01.02','Maintenance','/admin/editCSC.do','','02.01',3,'ROLE_M;ROLE_A','Service Counter Locator(Maker)');

INSERT INTO SEB.PORTAL_MODULE (NAME,DESCRIPTION,MODULE_CODE,CATEGORY,ACCESS_URL,IMAGE_CONTENT,PARENT_MODULE_CODE,LEVEL,ROLE,SUB_MODULE_NAME) VALUES ('News','Maintenance>News','02.02','Maintenance','','','02',2,'ROLE_A;ROLE_N;ROLE_C;ROLE_MAKER','');

INSERT INTO SEB.PORTAL_MODULE (NAME,DESCRIPTION,MODULE_CODE,CATEGORY,ACCESS_URL,IMAGE_CONTENT,PARENT_MODULE_CODE,LEVEL,ROLE,SUB_MODULE_NAME) VALUES ('Add','Maintenance>News>Add','02.02.01','Maintenance','/admin/addNews.do','','02.02',3,'ROLE_A;ROLE_N;ROLE_C;ROLE_MAKER','News');

INSERT INTO SEB.PORTAL_MODULE (NAME,DESCRIPTION,MODULE_CODE,CATEGORY,ACCESS_URL,IMAGE_CONTENT,PARENT_MODULE_CODE,LEVEL,ROLE,SUB_MODULE_NAME) VALUES ('Edit','Maintenance>News>Edit','02.02.02','Maintenance','/admin/editNews.do','','02.02',3,'ROLE_A;ROLE_N;ROLE_C;ROLE_MAKER','News');

INSERT INTO SEB.PORTAL_MODULE (NAME,DESCRIPTION,MODULE_CODE,CATEGORY,ACCESS_URL,IMAGE_CONTENT,PARENT_MODULE_CODE,LEVEL,ROLE,SUB_MODULE_NAME) VALUES ('Power Alert','Maintenance>Power Alert','02.03','Maintenance','','','02',2,'ROLE_A;ROLE_N;ROLE_C;ROLE_MAKER','Power Alert');

INSERT INTO SEB.PORTAL_MODULE (NAME,DESCRIPTION,MODULE_CODE,CATEGORY,ACCESS_URL,IMAGE_CONTENT,PARENT_MODULE_CODE,LEVEL,ROLE,SUB_MODULE_NAME) VALUES ('Add','Maintenance>Power Alert>Add','02.03.01','Maintenance','/admin/addPowerAlert.do','','02.03',3,'ROLE_A;ROLE_N;ROLE_C;ROLE_MAKER','Power Alert');

INSERT INTO SEB.PORTAL_MODULE (NAME,DESCRIPTION,MODULE_CODE,CATEGORY,ACCESS_URL,IMAGE_CONTENT,PARENT_MODULE_CODE,LEVEL,ROLE,SUB_MODULE_NAME) VALUES ('Edit','Maintenance>Power Alert>Edit','02.03.02','Maintenance','/admin/editPowerAlert.do','','02.03',3,'ROLE_A;ROLE_N;ROLE_C;ROLE_MAKER','');

INSERT INTO SEB.PORTAL_MODULE (NAME,DESCRIPTION,MODULE_CODE,CATEGORY,ACCESS_URL,IMAGE_CONTENT,PARENT_MODULE_CODE,LEVEL,ROLE,SUB_MODULE_NAME) VALUES ('Push Notification','Maintenance>Push Notification','02.04','Maintenance','','','02',2,'ROLE_A;ROLE_N;ROLE_C;ROLE_MAKER','');

INSERT INTO SEB.PORTAL_MODULE (NAME,DESCRIPTION,MODULE_CODE,CATEGORY,ACCESS_URL,IMAGE_CONTENT,PARENT_MODULE_CODE,LEVEL,ROLE,SUB_MODULE_NAME) VALUES ('Add','Maintenance>Push Notification>Add','02.04.01','Maintenance','/admin/addPushNotification.do','','02.04',3,'ROLE_A;ROLE_N;ROLE_C;ROLE_MAKER','Push Notification');

INSERT INTO SEB.PORTAL_MODULE (NAME,DESCRIPTION,MODULE_CODE,CATEGORY,ACCESS_URL,IMAGE_CONTENT,PARENT_MODULE_CODE,LEVEL,ROLE,SUB_MODULE_NAME) VALUES ('Edit','Maintenance>Push Notification>Edit','02.04.02','Maintenance','/admin/editPushNotification.do','','02.04',3,'ROLE_A;ROLE_N;ROLE_C;ROLE_MAKER','Push Notification');

INSERT INTO SEB.PORTAL_MODULE (NAME,DESCRIPTION,MODULE_CODE,CATEGORY,ACCESS_URL,IMAGE_CONTENT,PARENT_MODULE_CODE,LEVEL,ROLE,SUB_MODULE_NAME) VALUES ('FAQ','Maintenance>FAQ','02.05','Maintenance','','','02',2,'ROLE_A;ROLE_N;ROLE_C;ROLE_MAKER','');

INSERT INTO SEB.PORTAL_MODULE (NAME,DESCRIPTION,MODULE_CODE,CATEGORY,ACCESS_URL,IMAGE_CONTENT,PARENT_MODULE_CODE,LEVEL,ROLE,SUB_MODULE_NAME) VALUES ('Add','Maintenance>FAQ>Add','02.05.01','Maintenance','/admin/addFAQ.do','','02.05',3,'ROLE_A;ROLE_N;ROLE_C;ROLE_MAKER','FAQ');

INSERT INTO SEB.PORTAL_MODULE (NAME,DESCRIPTION,MODULE_CODE,CATEGORY,ACCESS_URL,IMAGE_CONTENT,PARENT_MODULE_CODE,LEVEL,ROLE,SUB_MODULE_NAME) VALUES ('Edit','Maintenance>FAQ>Edit','02.05.02','Maintenance','/admin/editFAQ.do','','02.05',3,'ROLE_A;ROLE_N;ROLE_C;ROLE_MAKER','FAQ');

INSERT INTO SEB.PORTAL_MODULE (NAME,DESCRIPTION,MODULE_CODE,CATEGORY,ACCESS_URL,IMAGE_CONTENT,PARENT_MODULE_CODE,LEVEL,ROLE,SUB_MODULE_NAME) VALUES ('Contact Us','Maintenance>Contact Us','02.06','Maintenance','/admin/contactUs.do','','02',2,'ROLE_A;ROLE_N;ROLE_C;ROLE_MAKER','');

INSERT INTO SEB.PORTAL_MODULE (NAME,DESCRIPTION,MODULE_CODE,CATEGORY,ACCESS_URL,IMAGE_CONTENT,PARENT_MODULE_CODE,LEVEL,ROLE,SUB_MODULE_NAME) VALUES ('User Management','User Management','03','User Management','','<span class="glyphicon glyphicon-user" aria-hidden="true"></span>','0',1,'ROLE_A;ROLE_N;ROLE_C;ROLE_MAKER','');

INSERT INTO SEB.PORTAL_MODULE (NAME,DESCRIPTION,MODULE_CODE,CATEGORY,ACCESS_URL,IMAGE_CONTENT,PARENT_MODULE_CODE,LEVEL,ROLE,SUB_MODULE_NAME) VALUES ('Add User','User Management>Add User','03.01','User Management','/admin/addUser.do','','03',2,'ROLE_A;ROLE_N;ROLE_C;ROLE_MAKER','');

INSERT INTO SEB.PORTAL_MODULE (NAME,DESCRIPTION,MODULE_CODE,CATEGORY,ACCESS_URL,IMAGE_CONTENT,PARENT_MODULE_CODE,LEVEL,ROLE,SUB_MODULE_NAME) VALUES ('Update User','User Management>Update User','03.02','User Management','/admin/editUser.do','','03',2,'ROLE_A;ROLE_N;ROLE_C;ROLE_MAKER','');

INSERT INTO SEB.PORTAL_MODULE (NAME,DESCRIPTION,MODULE_CODE,CATEGORY,ACCESS_URL,IMAGE_CONTENT,PARENT_MODULE_CODE,LEVEL,ROLE,SUB_MODULE_NAME) VALUES ('Module Access Manangement','User Management>Module Access Manangement','03.03','User Management','/admin/moduleAccessMgmt.do','','03',2,'ROLE_A;ROLE_N;ROLE_C;ROLE_MAKER','');

INSERT INTO SEB.PORTAL_MODULE (NAME,DESCRIPTION,MODULE_CODE,CATEGORY,ACCESS_URL,IMAGE_CONTENT,PARENT_MODULE_CODE,LEVEL,ROLE,SUB_MODULE_NAME) VALUES ('Policy','Policy','04','Policy','/admin/policy.do','<span class="glyphicon glyphicon-tag" aria-hidden="true"></span>','0',1,'ROLE_A;ROLE_N;ROLE_C;ROLE_MAKER','');

INSERT INTO SEB.PORTAL_MODULE (NAME,DESCRIPTION,MODULE_CODE,CATEGORY,ACCESS_URL,IMAGE_CONTENT,PARENT_MODULE_CODE,LEVEL,ROLE,SUB_MODULE_NAME) VALUES ('Report','Report','05','Report','','<span class="glyphicon glyphicon-file" aria-hidden="true"></span>','0',1,'ROLE_A;ROLE_N;ROLE_C;ROLE_MAKER','');

INSERT INTO SEB.PORTAL_MODULE (NAME,DESCRIPTION,MODULE_CODE,CATEGORY,ACCESS_URL,IMAGE_CONTENT,PARENT_MODULE_CODE,LEVEL,ROLE,SUB_MODULE_NAME) VALUES ('Make A Report','Report>Make A Report','05.01','Report','/admin/makeAReport.do','','05',2,'ROLE_A;ROLE_N;ROLE_C;ROLE_MAKER','');

INSERT INTO SEB.PORTAL_MODULE (NAME,DESCRIPTION,MODULE_CODE,CATEGORY,ACCESS_URL,IMAGE_CONTENT,PARENT_MODULE_CODE,LEVEL,ROLE,SUB_MODULE_NAME) VALUES ('Customer Activities Report','Report>Customer Activities Report','05.02','Report','/admin/customerActivityReport.do','','05',2,'ROLE_A;ROLE_N;ROLE_C;ROLE_MAKER','');

INSERT INTO SEB.PORTAL_MODULE (NAME,DESCRIPTION,MODULE_CODE,CATEGORY,ACCESS_URL,IMAGE_CONTENT,PARENT_MODULE_CODE,LEVEL,ROLE,SUB_MODULE_NAME) VALUES ('Audit Trail','Report>Audit Trail','05.03','Report','/admin/auditTrails.do','','05',2,'ROLE_A;ROLE_N;ROLE_C;ROLE_MAKER','');
	
create table seb.access_rights (
	 id	integer	not null	generated always
		as identity (start with 1, increment by 1, cache 20,
			 no minvalue, no maxvalue, no cycle, no order),
	admin_user_id integer default null,
	portal_module_id	integer	default null,
	created_datetime timestamp not null with default,
	updated_datetime timestamp generated always for each row on update as row change timestamp not null,
	deleted_flag	integer not null with default,
	primary key (id),
	foreign key admin_user_at_fk (admin_user_id) references seb.admin_user on delete no action,
	foreign key portal_module_at_fk (portal_module_id) references seb.portal_module on delete no action
 );
 
 
INSERT INTO SEB.ACCESS_RIGHTS (ADMIN_USER_ID,PORTAL_MODULE_ID)  SELECT  1,ID  FROM SEB.PORTAL_MODULE WHERE MODULE_CODE IN('03','03.01','03.02','03.03','05','05.01','05.02','05.03');

